import sys
faces = {}
vertices = set()
with open(sys.argv[1]) as f:
    for line in iter(f.readline, ""):
        words = line.rstrip("\r\n").split(" ")
        if words[0] == "face":
            face, vertex = words[1:3]
            faces.setdefault(face, [])
            faces[face].append(vertex)
            vertices.add(vertex)
n = len(vertices)
adj = [[0]*n for _ in range(n)]
vindices = {v:i for i,v in enumerate(sorted(vertices))}
for vlist in faces.values():
    for i in range(len(vlist)):
        v, w = vlist[i-1], vlist[i]
        vi, wi = vindices[v], vindices[w]
        adj[vi][wi] = 1
        adj[wi][vi] = 1

si = vindices[sys.argv[2]]
ti = vindices[sys.argv[3]]

sys.stdout.write("""\
n : {n};
M : matrix({mx});
V : matrix({sv});
W : lambda([i], if i=0 then V else M.W(i-1));
w : lambda([i], W(i)[{ti}][1]);
h : sum(w(i) * x^i, i, 0, n-1);
P : expand(charpoly(M, x));
Q : expand(x^n * subst(x=1/x,P));
g : remainder(expand(h*Q), x^n) / Q;
taylor(g, x, 0, 20);
""".format(n=n,
           mx=",".join(str(row) for row in adj),
           sv=",".join("[1]" if i==si else "[0]" for i in range(n)),
           ti=ti+1))
